"use strict";
// OrFilterStrategy.ts
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrFilterStrategy = void 0;
class OrFilterStrategy {
    /**
     * The function applies a filter to an array of strings and returns a new array containing only the
     * elements that match the filter values.
     * @param {string[]} data - An array of strings representing the data that needs to be filtered.
     * @param {string[]} filterValues - An array of strings representing the values to filter the data
     * array with.
     * @returns an array of strings.
     */
    applyFilter(data, filterValues) {
        return data.every(item => filterValues.includes(item))
            ? data.filter(item => filterValues.includes(item))
            : [];
    }
}
exports.OrFilterStrategy = OrFilterStrategy;
//# sourceMappingURL=orFilterStrategy.js.map