import { Getter, Provider } from '@loopback/core';
import { FeatureHandlerService } from '../services';
import { FeatureFlagFn, FeatureFlagMetadata, FilterStrategy, FilterType, IAuthUserWithDisabledFeat } from '../types';
export declare class FeatureFlagActionProvider implements Provider<FeatureFlagFn> {
    private readonly getMetadata;
    private readonly user?;
    private readonly handlerService?;
    filterStrategyMapping: {
        filterType: FilterType;
        strategy: FilterStrategy;
    }[];
    constructor(getMetadata: Getter<FeatureFlagMetadata>, user?: IAuthUserWithDisabledFeat | undefined, handlerService?: FeatureHandlerService | undefined);
    value(): FeatureFlagFn;
    action(): Promise<boolean>;
    getStrategy(operator: FilterType | undefined): FilterStrategy;
}
