"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFeatureFlagMetadata = exports.FeatureFlagMetadataProvider = void 0;
const tslib_1 = require("tslib");
// Copyright (c) 2023 Sourcefuse Technologies
//
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT
const core_1 = require("@loopback/core");
const keys_1 = require("../keys");
let FeatureFlagMetadataProvider = class FeatureFlagMetadataProvider {
    constructor(controllerClass, methodName) {
        this.controllerClass = controllerClass;
        this.methodName = methodName;
    }
    value() {
        if (!this.controllerClass || !this.methodName)
            return;
        return getFeatureFlagMetadata(this.controllerClass, this.methodName);
    }
};
exports.FeatureFlagMetadataProvider = FeatureFlagMetadataProvider;
exports.FeatureFlagMetadataProvider = FeatureFlagMetadataProvider = tslib_1.__decorate([
    tslib_1.__param(0, (0, core_1.inject)(core_1.CoreBindings.CONTROLLER_CLASS, { optional: true })),
    tslib_1.__param(1, (0, core_1.inject)(core_1.CoreBindings.CONTROLLER_METHOD_NAME, { optional: true })),
    tslib_1.__metadata("design:paramtypes", [Object, String])
], FeatureFlagMetadataProvider);
function getFeatureFlagMetadata(controllerClass, methodName) {
    return core_1.MetadataInspector.getMethodMetadata(keys_1.FEATURE_FLAG_METADATA_ACCESSOR, controllerClass.prototype, methodName);
}
exports.getFeatureFlagMetadata = getFeatureFlagMetadata;
//# sourceMappingURL=feature-flag-metadata.provider.js.map