"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureHandlerService = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const types_1 = require("../types");
const rest_1 = require("@loopback/rest");
let FeatureHandlerService = class FeatureHandlerService {
    constructor(getHandlers) {
        this.getHandlers = getHandlers;
    }
    async findHandler(handlerName) {
        const handlers = await this.getHandlers();
        return handlers.find(h => h.handlerName === handlerName);
    }
    async handle(featureMetadata, currentUser) {
        var _a, _b;
        if ((_a = featureMetadata.options) === null || _a === void 0 ? void 0 : _a.handler) {
            const handler = await this.findHandler((_b = featureMetadata.options) === null || _b === void 0 ? void 0 : _b.handler);
            if (handler) {
                return handler.handle(featureMetadata, currentUser);
            }
            else {
                throw new rest_1.HttpErrors.InternalServerError('No Handler Found');
            }
        }
        else {
            return true;
        }
    }
};
exports.FeatureHandlerService = FeatureHandlerService;
exports.FeatureHandlerService = FeatureHandlerService = tslib_1.__decorate([
    (0, core_1.extensionPoint)(types_1.HANDLER_EXTENSION_POINT_NAME),
    tslib_1.__param(0, (0, core_1.extensions)()),
    tslib_1.__metadata("design:paramtypes", [Function])
], FeatureHandlerService);
//# sourceMappingURL=feature-handler-service.js.map